/***************************************************************************
                          myfilepicker.cpp  -  description
                             -------------------
    begin                : Sun Jun 17 2001
    copyright            : (C) 2001 by Rdiger Knrig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "myfilepicker.h"
#include <qstring.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtooltip.h>
#include <qfiledialog.h>

MyFilePicker::MyFilePicker(QString explanation,const QString &defaulttext,QWidget *parent, const char *name ) : QWidget(parent,name)
{
	
	mainlayout = new QHBoxLayout(this,2,5,"mainlayout");
	this->explanation = new QLabel(explanation,this);
	entry = new QLineEdit(defaulttext,this,"entry");
	entry->setSizePolicy(QSizePolicy(QSizePolicy::MinimumExpanding,QSizePolicy::Fixed));
	pickbutton = new QPushButton("Pick...",this,"pickbutton");
	QToolTip::add(pickbutton,"select a file");
	
	mainlayout->addWidget(this->explanation,0,Qt::AlignLeft);
	mainlayout->addWidget(entry,1,Qt::AlignLeft);
	mainlayout->addWidget(pickbutton,0,Qt::AlignRight);
	
	QObject::connect(pickbutton,SIGNAL(clicked()),this,SLOT(slotPickFile()));
}

MyFilePicker::~MyFilePicker()
{

}

/**
	* invokes a file dialog for setting
	* the filename  displayed in entry
	*/
void MyFilePicker::slotPickFile()
{
	QString filename(QFileDialog::getOpenFileName(entry->text(),"all files (*)",this));
	
	if(!filename.isEmpty()) entry->setText(filename);
	
}

	
