/***************************************************************************
                          mysetupdialog.h  -  description
                             -------------------
    begin                : Thu Jun 14 2001
    copyright            : (C) 2001 by Rdiger Knrig
    email                : ruediger@knoerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYSETUPDIALOG_H
#define MYSETUPDIALOG_H

#include <qwidget.h>
#include <qdialog.h>
#include <qlayout.h>

class QPushButton;
class QString;
class QStringList;
class QFile;
class QDataStream;
class QGroupBox;
class MyFilePicker;
class MyListView;

/**setup dialog for a2psfrontend
  *@author Rdiger Knrig
  */

class MySetupDialog : public QDialog  {
   Q_OBJECT
public: 
	MySetupDialog(QString configfilename, QString *a2psexec, QString *gvexec, QStringList *codecs,\
	QStringList *printers,QWidget *parent=0, const char *name=0);
	~MySetupDialog();
protected:
	/** button fpr save & exit */
	QPushButton *okbutton;
	/** button for backoff (holds homedir clean) */
	QPushButton *cancelbutton;
	/** filepicker for the a2ps command */
	MyFilePicker *commandpicker;
	/** filepicker for the viewer command */
	MyFilePicker *viewerpicker;
	/** frames command string pickers, improves dialogs content structure */
	QGroupBox *pickerbox;
	/** list view for predefined printer choices */
	MyListView *printerlist;
	/** list view for predefined codec choices */
	MyListView *codeclist;
	/** frames listviews */
	QGroupBox *listviewbox;
	/** main layout */
	QVBoxLayout *mainlayout;
	/** layout for the buttons */
	QHBoxLayout *buttonlayout;
	/** stream-end to configuration file */
	QFile *output;
	/** QDataStream for writing the configuration data */
	QDataStream *downstream;
	/** reference to command string invoking a2ps */
	QString *a2ps;
	/** reference to command string invoking the postskript viewer */
	QString *gv;
	/** stringlist with codecs */
	QStringList *codecs;
	/** stringlist with printers */
	QStringList *printers;
protected slots: // Protected slots
  /** user accepted settings, so we change
the attributes and the config file */
  void slotAccept();
};

#endif
